/*
Copyright 2022 Huawei Cloud Computing Technologies Co., Ltd.

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

 http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.
*/
// Code generated by tmpl; DO NOT EDIT.
// https://github.com/benbjohnson/tmpl
//
// Source: message_types.go.tmpl

package netstorage

import (
	"github.com/openGemini/openGemini/lib/codec"
)

const (
	UnknownMessage uint8 = iota

	SeriesKeysRequestMessage
	SeriesKeysResponseMessage

	SeriesExactCardinalityRequestMessage
	SeriesExactCardinalityResponseMessage

	SeriesCardinalityRequestMessage
	SeriesCardinalityResponseMessage

	ShowTagValuesRequestMessage
	ShowTagValuesResponseMessage

	ShowTagValuesCardinalityRequestMessage
	ShowTagValuesCardinalityResponseMessage

	GetShardSplitPointsRequestMessage
	GetShardSplitPointsResponseMessage

	DeleteRequestMessage
	DeleteResponseMessage

	CreateDataBaseRequestMessage
	CreateDatabaseResponseMessage
)

func NewMessage(typ uint8) codec.BinaryCodec {
	switch typ {
	case SeriesKeysRequestMessage:
		return &SeriesKeysRequest{}
	case SeriesKeysResponseMessage:
		return &SeriesKeysResponse{}
	case SeriesExactCardinalityRequestMessage:
		return &SeriesExactCardinalityRequest{}
	case SeriesExactCardinalityResponseMessage:
		return &SeriesExactCardinalityResponse{}
	case SeriesCardinalityRequestMessage:
		return &SeriesCardinalityRequest{}
	case SeriesCardinalityResponseMessage:
		return &SeriesCardinalityResponse{}
	case ShowTagValuesRequestMessage:
		return &ShowTagValuesRequest{}
	case ShowTagValuesResponseMessage:
		return &ShowTagValuesResponse{}
	case ShowTagValuesCardinalityRequestMessage:
		return &ShowTagValuesCardinalityRequest{}
	case ShowTagValuesCardinalityResponseMessage:
		return &ShowTagValuesCardinalityResponse{}
	case GetShardSplitPointsRequestMessage:
		return &GetShardSplitPointsRequest{}
	case GetShardSplitPointsResponseMessage:
		return &GetShardSplitPointsResponse{}
	case DeleteRequestMessage:
		return &DeleteRequest{}
	case DeleteResponseMessage:
		return &DeleteResponse{}
	case CreateDataBaseRequestMessage:
		return &CreateDataBaseRequest{}
	case CreateDatabaseResponseMessage:
		return &CreateDataBaseResponse{}
	default:
		return nil
	}
}

func GetResponseMessageType(typ uint8) uint8 {
	switch typ {
	case SeriesKeysRequestMessage:
		return SeriesKeysResponseMessage
	case SeriesExactCardinalityRequestMessage:
		return SeriesExactCardinalityResponseMessage
	case SeriesCardinalityRequestMessage:
		return SeriesCardinalityResponseMessage
	case ShowTagValuesRequestMessage:
		return ShowTagValuesResponseMessage
	case ShowTagValuesCardinalityRequestMessage:
		return ShowTagValuesCardinalityResponseMessage
	case GetShardSplitPointsRequestMessage:
		return GetShardSplitPointsResponseMessage
	case DeleteRequestMessage:
		return DeleteResponseMessage
	default:
		return UnknownMessage
	}
}
